//Generated by the protocol buffer compiler. DO NOT EDIT!
// source: dsepractice/chinese/v1alpha1/core_types.proto

package gg.dsepractice.chinese.v1alpha1;

@kotlin.jvm.JvmName("-initializelistArticlesResponse")
inline fun listArticlesResponse(block: gg.dsepractice.chinese.v1alpha1.ListArticlesResponseKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.ListArticlesResponse =
  gg.dsepractice.chinese.v1alpha1.ListArticlesResponseKt.Dsl._create(gg.dsepractice.chinese.v1alpha1.ListArticlesResponse.newBuilder()).apply { block() }._build()
object ListArticlesResponseKt {
  @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
  @com.google.protobuf.kotlin.ProtoDslMarker
  class Dsl private constructor(
    private val _builder: gg.dsepractice.chinese.v1alpha1.ListArticlesResponse.Builder
  ) {
    companion object {
      @kotlin.jvm.JvmSynthetic
      @kotlin.PublishedApi
      internal fun _create(builder: gg.dsepractice.chinese.v1alpha1.ListArticlesResponse.Builder): Dsl = Dsl(builder)
    }

    @kotlin.jvm.JvmSynthetic
    @kotlin.PublishedApi
    internal fun _build(): gg.dsepractice.chinese.v1alpha1.ListArticlesResponse = _builder.build()

    /**
     * An uninstantiable, behaviorless type to represent the field in
     * generics.
     */
    @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
    class ArticlesProxy private constructor() : com.google.protobuf.kotlin.DslProxy()
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     */
     val articles: com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.Article, ArticlesProxy>
      @kotlin.jvm.JvmSynthetic
      get() = com.google.protobuf.kotlin.DslList(
        _builder.getArticlesList()
      )
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     * @param value The articles to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("addArticles")
    fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.Article, ArticlesProxy>.add(value: gg.dsepractice.chinese.v1alpha1.Article) {
      _builder.addArticles(value)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     * @param value The articles to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("plusAssignArticles")
    @Suppress("NOTHING_TO_INLINE")
    inline operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.Article, ArticlesProxy>.plusAssign(value: gg.dsepractice.chinese.v1alpha1.Article) {
      add(value)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     * @param values The articles to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("addAllArticles")
    fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.Article, ArticlesProxy>.addAll(values: kotlin.collections.Iterable<gg.dsepractice.chinese.v1alpha1.Article>) {
      _builder.addAllArticles(values)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     * @param values The articles to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("plusAssignAllArticles")
    @Suppress("NOTHING_TO_INLINE")
    inline operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.Article, ArticlesProxy>.plusAssign(values: kotlin.collections.Iterable<gg.dsepractice.chinese.v1alpha1.Article>) {
      addAll(values)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     * @param index The index to set the value at.
     * @param value The articles to set.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("setArticles")
    operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.Article, ArticlesProxy>.set(index: kotlin.Int, value: gg.dsepractice.chinese.v1alpha1.Article) {
      _builder.setArticles(index, value)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("clearArticles")
    fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.Article, ArticlesProxy>.clear() {
      _builder.clearArticles()
    }

    /**
     * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
     */
    var paginationInfo: gg.dsepractice.chinese.v1alpha1.PaginationInfo
      @JvmName("getPaginationInfo")
      get() = _builder.getPaginationInfo()
      @JvmName("setPaginationInfo")
      set(value) {
        _builder.setPaginationInfo(value)
      }
    /**
     * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
     */
    fun clearPaginationInfo() {
      _builder.clearPaginationInfo()
    }
    /**
     * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
     * @return Whether the paginationInfo field is set.
     */
    fun hasPaginationInfo(): kotlin.Boolean {
      return _builder.hasPaginationInfo()
    }
  }
}
inline fun gg.dsepractice.chinese.v1alpha1.ListArticlesResponse.copy(block: gg.dsepractice.chinese.v1alpha1.ListArticlesResponseKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.ListArticlesResponse =
  gg.dsepractice.chinese.v1alpha1.ListArticlesResponseKt.Dsl._create(this.toBuilder()).apply { block() }._build()

val gg.dsepractice.chinese.v1alpha1.ListArticlesResponseOrBuilder.paginationInfoOrNull: gg.dsepractice.chinese.v1alpha1.PaginationInfo?
  get() = if (hasPaginationInfo()) getPaginationInfo() else null

